#include<bits/stdc++.h>
using namespace std;
#define MAXN 100007
#define v1 v[x][q]
vector<int> v[MAXN];
int n;
bool b[MAXN];
int dp[MAXN];
void f(int x)
{
    if (b[x]) return;
    b[x]=1;
    dp[x]=v[x].size();
    for (int q=0;q<v[x].size();q++)
    {
        f(v1);
        dp[x]+=dp[v1];
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for (int q=0;q<n-1;q++)
    {
        int a,b;
        cin>>a>>b;
        v[a].push_back(b);
    }
    for (int q=1;q<=n;q++) f(q);
    int qq;
    cin>>qq;
    for (int q=0;q<qq;q++)
    {
        int a;
        cin>>a;
        cout<<dp[a]<<"\n";
    }
}
